/*
 * Copyright, 2012, Teradek
 *
 * All rights reserved.
 * Contact Teradek for licensing.
 */


#ifndef _MOBISTATUS_H_
#define _MOBISTATUS_H_
#include <stdarg.h>

typedef enum _BroadcastState {
    BROADCAST_STATE_READY = 0,
    BROADCAST_STATE_CONNECTING,
    BROADCAST_STATE_AUTHENTICATING,
    BROADCAST_STATE_CONNECTED,
    BROADCAST_STATE_FORCE_RECONNECT,
    BROADCAST_STATE_DISCONNECTED,
    BROADCAST_STATE_RECONNECTING,
    BROADCAST_STATE_CLOSING,
    BROADCAST_STATE_CLOSE,
    BROADCAST_STATE_WARNING,
    BROADCAST_STATE_ERROR,
    BROADCAST_STATE_INVALID
} BroadcastState;

typedef enum _BroadcastError {
    BROADCAST_NO_ERROR = 0,
    BROADCAST_CONNECTION_ERROR,
    BROADCAST_WARNING,
    BROADCAST_ERROR
} BroadcastError;

typedef enum _RecordState {
    RECORD_STATE_READY = 0,
    RECORD_STATE_STARTING,
    RECORD_STATE_RECORDING,
    RECORD_STATE_STOPPING,
    RECORD_STATE_DONE,
    RECORD_STATE_STOPPED
} RecordingState;

int mobistatus_broadcast(BroadcastState state, int recordFlagIsSet);
int mobistatus_broadcast_error_va(BroadcastError type, char *error_str, va_list arg);
int mobistatus_broadcast_error(BroadcastError type, char *error_str, ...);
int mobistatus_update_msg(char *name, char *value, char *description);

int mobistatus_record_state(RecordingState state);
int tdnotifyPublishUpdate(char *priority, char *name, char *value, char *description);

#endif /* _MOBISTATUS_H_ */
