/*
 * Copyright, 2011, Teradek
 * 
 * All rights reserved.
 * Contact Teradek for licensing.
 */

#ifndef _UTILS_H_
#define _UTILS_H_

#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <stdint.h>
#include <sys/time.h>

#define UTILS_MIN(a,b) (((a) < (b)) ? (a) : (b))

#ifdef __cplusplus
  extern "C" {
#endif

uint32_t time_elapsed_ms(struct timeval last_time);
int64_t time64_elapsed_ms(struct timeval last_time);
int64_t current_time64_ms();
void dump(char *buf, int len);
void text_decrypt(char *buf, int sz, uint32_t session_id);
void text_encrypt(char *buf, int sz, uint32_t session_id);

#ifdef __cplusplus
  }
#endif

#ifdef __cplusplus
#include <string>

using namespace std;

void dump(uint8_t *buf, int len);

long str2int(const string& str);
string int2str(long n);

// Takes param_num's (starting from 0) parameter in string str like 123:32:2222:34 and copies result to res
bool get_param(int param_num, const string& str, string& res, string separator = ":,");

// Parse string like <spaces>LHS<spaces><separator><spaces>RHS<spaces> (e.g., protocol=tcp)
bool parse_statement(const string& statement, string& lhs, string& rhs, string separators="=", string spaces=" ");

#endif

#endif /* _UTILS_H_ */
